
import re


def getOperator(opString):
    if opString == '>':
        return GtOperator()
    elif opString == '>=':
        return GtOrEqualsOperator()
    elif opString == '<':
        return LtOperator()
    elif opString == '<=':
        return LtOrEqualsOperator()
    elif opString == '=':
        return EqualsOperator()
    elif opString == '!=':
        return NotEqualsOperator()

    return None

class LtOperator(object):
    def evaluate(self, value1, value2):
        return value1 < value2

    def getReverseOperator(self):
        return GtOrEqualsOperator()

    def isLessComparison(self):
        return True

    def isGreaterComparison(self):
        return False

class LtOrEqualsOperator(object):
    def evaluate(self, value1, value2):
        return value1 <= value2

    def getReverseOperator(self):
        return GtOperator()

    def isLessComparison(self):
        return True

    def isGreaterComparison(self):
        return False

class GtOperator(object):
    def evaluate(self, value1, value2):
        return value1 > value2

    def getReverseOperator(self):
        return LtOrEqualsOperator()

    def isLessComparison(self):
        return False

    def isGreaterComparison(self):
        return True

class GtOrEqualsOperator(object):
    def evaluate(self, value1, value2):
        return value1 >= value2

    def getReverseOperator(self):
        return LtOperator()

    def isLessComparison(self):
        return False

    def isGreaterComparison(self):
        return True

class EqualsOperator(object):
    def evaluate(self, value1, value2):
        return value1 == value2

    def getReverseOperator(self):
        return NotEqualsOperator()

    def isLessComparison(self):
        return False

    def isGreaterComparison(self):
        return False

class NotEqualsOperator(object):
    def evaluate(self, value1, value2):
        return value1 != value2

    def getReverseOperator(self):
        return EqualsOperator()

    def isLessComparison(self):
        return False

    def isGreaterComparison(self):
        return False
