
import json, time
from mqttlogic import AlarmConfig

class PendingAlarm(object):

    def __init__(self, mqttPath, alarmConfig):
        self.mqttPath = mqttPath
        self.alarmConfig = alarmConfig

    def setTask(self, asyncioTask):
        self.asyncioTask = asyncioTask

    # check if a delayed alarm should be stopped (if trigger conditions for same sensor do not apply anymore)
    def cancelAlarmIfNoMatch(self, mqttPath, sensorData, ts):
        if mqttPath == self.mqttPath and self.alarmConfig.getTriggerDelay(mqttPath, sensorData, ts) >= 0:
            self.asyncioTask.cancel()
